/* 
 * macdialog.h
 */

#define aboutBox 1

/* Resource pointers for dialog, and enumerated types for each control item */
/* postfix codes are used to identify different types of control item :

		ST = static text
		ET = editable text
		SB = slider bar
		CB = check box
		PI = picture
		IC = icon
		BU = button
		RB = radio button
*/

#include "rayshade.h"

#define aboutboxR 129


#define renderoptionsR 128
enum {
	renderoptionsST = 1,
	rayspixelSB,
	rayspixelST,
	rayspixelET,
	treedepthSB,
	treedepthST,
	treedepthET,
	shadowsCB,
	jitterCB,
	cameraBU,
	useBU,
	cancelBU,
	defaultBU,
	screenBU,
	threshholdET,
	threshholdST
} ;

#define erroralertR 130

#define screenoptionsR 131
enum {
	fiftybyfiftyRB =1 ,
	hundredbyhundredRB,
	twohundredbytwohundredRB,
	customRB,
	customxET,
	customyET,
	xST,
	screenuseBU,
	screencancelBU,
	horizlinePI,
	screenoptionsST,
	resolutionST,
	magnificationST,
	onebyonemagRB,
	twobytwomagRB,
	fourbyfourmagRB,
	eightbyeightmagRB,
	sixteenbysixteenmagRB,
	thirtytwobythirtytwomagRB
} ;

#define cameraoptionsR 132
enum {
	camerauseBU = 1,
	cameracancelBU,
	cameraoptionsST,
	observerxET,
	observeryET,
	observerzET,
	targetxET,
	targetyET,
	targetzET,
	observerST,
	targetST,
	upvectorxET,
	upvectoryET,
	upvectorzET,
	upvectorST,
	upvectorxST,
	upvectoryST,
	upvectorzST,
	observerxST,
	observeryST,
	observerzST,
	targetxST,
	targetyST,
	targetzST,
	apertureST,
	apertureET,
	focaldistanceST,
	focaldistanceET,
	fieldofvisionST,
	fieldofvisionET,
	fieldofvisiondegreeST,
	camerahorizlinePI,
	cameraiconIC,
	crosshair2observerBU=34,
	crosshair2targetBU,
	crosshair2upvectorBU
} ;

#define newobjectR 134
enum {
	objectcreateBU=1,
	objectcancelBU=6,
	objecttypeCI=2,
	objectnameET=3
} ;


#define framessetR 143
enum {
	frameuseBU = 1,
	framecancelBU,
	framestartET,
	frameendET
} ;

#define gridsizeR 151
enum {
	griduseBU = 1,
	gridxBU = 4,
	gridyBU = 6,
	gridzBU = 8
};

/* Some key codes */

enum  {
	kEnterKey = 0x03,
    kBackSpace = 0x08,
    kTabKey,
    kReturnKey = 0x0D,
    kEscKey = 0x1B,
    kLeftArrow,
    kRightArrow,
    kUpArrow,
    kDownArrow,
    kDeleteKey = 0x7F
};

int StrtoFloat(Str255 num, Float *result) ;
void SetFloatEditText(DialogPtr myDialog, short itemno, Float value) ;
void SetFloatStringText(DialogPtr myDialog, short itemno, char *str, Float value) ;
void SetIntEditText(DialogPtr myDialog, short itemno, int value) ;
void SetIntStringText(DialogPtr myDialog, short itemno, char *str, int value) ;
void PickColour(Color *col) ;
void SetRenderOptions() ;
void SetScreenOptions() ;
void SetCameraOptions() ;
void GetClick() ;
pascal Boolean screenoptionsfilter(DialogPtr dialer, EventRecord *myDialogEvent, short *theDialogItem) ;
pascal Boolean cameraoptionsfilter(DialogPtr dialer, EventRecord *myDialogEvent, short *theDialogItem) ;
pascal Boolean renderoptionsfilter(DialogPtr dialer, EventRecord *myDialogEvent, short *theDialogItem) ;
pascal void DrawHilite(WindowPtr theWindow, short itemNo) ;
ControlHandle SnatchHandle(DialogPtr thebox, short theGetItem) ;
Boolean IsEditKey(char theKey) ;
char ValidFloat(Float min, Float Max, Str255 num) ;
char GetFloatEditText(DialogPtr myDialog, short theItem, Float *value) ;
char GetIntEditText(DialogPtr myDialog, short theItem, int *value) ;
