/*
 * macmenus.h
 *
 */

/* resource IDs of menus */

#define appleID			1
#define fileID			2
#define editID			3
#define renderID		128
#define objectID		130

/* Menu indices */
#define appleM			0
#define fileM			1
#define editM			2
#define renderM			3
#define objectM			4

#define aboutBox 129

#define aboutItem 1

/* Now the enumerated menu options */

/* File menu */
enum	{
	newItem  = 1,
	openItem,
	closeItem = 4,
	saveItem,
	saveimageItem = 7,
	quitItem = 9
};

/* Edit menu */
enum {
	undoItem = 1,
	cutItem,
	copyItem,
	pasteItem,
	clearItem
} ;

/* Render menu */
enum {
	raytraceItem = 1,
	previewItem,
	raytracecrop,
	renderoptionsItem = 5,
	screenoptionsItem,
	cameraoptionsItem,
	showoptionsItem
} ;

/* object menu */
enum {
	createobjectItem = 1,
	modifyobjectItem
} ;

/* Now for a structure to hold all the information we need to keep the menu correct */

struct menuinfo {
	char scene_in_memory ;		/* Do we have a scene in memory */
	char rendered_image ;		/* Is there an image window open  */
	char rendering ;			/* Are we rendering at the moment */
} ;

void AdjustMenus(void); 
void HandleMenu (long mSelect);
void SetUpMenus(void);
void PrepareScript() ;
void PreviewRender() ;
void OpenNewScript();
