/*
 * Macobject.h
 */


#define MAXPOINTS 100
#define MAXTRANSFORMS 50

#define EDGE_BETWEEN(x,y) theObject->edge_array[y][x]

/* Wireframe object definition */

struct wobject {
	Vector points[MAXPOINTS] ;			/* Real points in space */
	short sxpoints[MAXPOINTS],sypoints[MAXPOINTS] ;			/* Points converted to 2d */
	char edge_array[MAXPOINTS][MAXPOINTS] ;
	short numpoints ;
} ;

typedef struct wobject WireObject ;

void CreateWireBox(register Box *box) ;
void CreateWireTriangle(register Triangle *tri) ;
void CreateWireSphere(register Sphere *sphere) ;
void CreateWirePlane(register Plane *plane) ;
void CreateWirePolygon(register RPolygon *poly) ;
void CreateWireDisc(register Disc *disc) ;
void CreateWireMetaBall(register MetaVector *mv);
void CreateWireCone(register Cone *cone) ;
void CreateWireCylinder(register Cylinder *cyl) ;
void CreateWireTorus(register Torus *tor) ;
void WireFrameTransform(Trans *trans) ;
void DrawObject(register Geom *object, register Surface *surf, register char viewdir) ;